#include "Form1.frm"

/*
 * Evento OnHeaderClick.
 */
METHOD TStringGrid1OnHeaderClick( oSender, nCol ) CLASS TForm1

   MessageDlg( "Click en la cabecera, columna " + LTrim( Str( nCol ) ), ;
               mtInformation, mbOk )

return

/*
 * Evento OnFooterClick.
 */
METHOD TStringGrid1OnFooterClick( oSender, nCol ) CLASS TForm1

   MessageDlg( "Click en el pi, columna " + LTrim( Str( nCol ) ), ;
               mtInformation, mbOk )

return

/*
 * Evento OnCreate.
 */
METHOD Form1OnCreate( oSender ) CLASS TForm1

   local aArray, aSubArray, nI, nJ

   aArray := {}
   nJ := Seconds()

   for nI := 1 to 1000
      aSubArray := {"  "}
      AAdd( aSubArray, LTrim( Str( nI ) ) )
      nJ /= 2
      AAdd( aSubArray, LTrim( Str( nJ, 12, 3 ) ) )
      nJ *= 1.5
      AAdd( aSubArray, LTrim( Str( nJ, 12, 3 ) ) )
      nJ /= 2
      AAdd( aSubArray, LTrim( Str( nJ, 12, 3 ) ) )
      nJ *= 1.5
      AAdd( aSubArray, LTrim( Str( nJ, 12, 3 ) ) )
      nJ /= 2
      AAdd( aSubArray, LTrim( Str( nJ, 12, 3 ) ) )
      AAdd( aArray, aSubArray )
      nJ *= 3.55
   next

   ::TStringGrid1:Items := aArray
   ::TStringGrid1:OnSearch := { | oSender, cBuffer | ;
                                If( Val( cBuffer ) < Len( ::TStringGrid1:Items ), ;
                                ::TStringGrid1:Row := Val( cBuffer ), ;
                                ::TStringGrid1:Row := Len( ::TStringGrid1:Items ) ) }
   
return

/*
 * Evento OnChange.
 */
METHOD CheckBox1OnChange( oSender ) CLASS TForm1

   if ::CheckBox1:Checked
      if ::CheckBox2:Checked
         ::TStringGrid1:ScrollBars := ssBoth
      else
         ::TStringGrid1:ScrollBars := ssHorizontal
      endif
   else
      if ::CheckBox2:Checked
         ::TStringGrid1:ScrollBars := ssVertical
      else
         ::TStringGrid1:ScrollBars := ssNone
      endif
   endif

   ::TStringGrid1:SetFocus()
   
return

/*
 * Evento OnChange.
 */
METHOD CheckBox2OnChange( oSender ) CLASS TForm1

   if ::CheckBox2:Checked
      if ::CheckBox1:Checked
         ::TStringGrid1:ScrollBars := ssBoth
      else
         ::TStringGrid1:ScrollBars := ssVertical
      endif
   else
      if ::CheckBox1:Checked
         ::TStringGrid1:ScrollBars := ssHorizontal
      else
         ::TStringGrid1:ScrollBars := ssNone
      endif
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD CheckBox3OnChange( oSender ) CLASS TForm1

   ::TStringGrid1:ShowHeader := ::CheckBox3:Checked
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD CheckBox4OnChange( oSender ) CLASS TForm1

   ::TStringGrid1:ShowFooter := ::CheckBox4:Checked
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD CheckBox5OnChange( oSender ) CLASS TForm1

   ::TStringGrid1:AutoExpand := ::CheckBox5:Checked
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD CheckBox7OnChange( oSender ) CLASS TForm1

   ::TStringGrid1:GridHorizontal := ::CheckBox7:Checked
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD CheckBox8OnChange( oSender ) CLASS TForm1

   ::TStringGrid1:GridVertical := ::CheckBox8:Checked
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD CheckBox9OnChange( oSender ) CLASS TForm1

   ::TStringGrid1:RowSelect := ::CheckBox9:Checked
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton1OnClick( oSender ) CLASS TForm1

   ::ColorDialog1:Caption := "Color de la rejilla"
   ::ColorDialog1:Color := ::TStringGrid1:GridColor

   if ::ColorDialog1:Execute()
      ::TStringGrid1:GridColor := ::ColorDialog1:Color
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton2OnClick( oSender ) CLASS TForm1

   ::FontDialog1:Font:Assign( ::TStringGrid1:Font )
   ::FontDialog1:Caption := "Fuente normal"

   if ::FontDialog1:Execute()
      ::TStringGrid1:Font:Assign( ::FontDialog1:Font )
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton3OnClick( oSender ) CLASS TForm1

   ::FontDialog1:Font:Assign( ::TStringGrid1:SelectedFont )
   ::FontDialog1:Caption := "Fuente con foco"

   if ::FontDialog1:Execute()
      ::TStringGrid1:SelectedFont:Assign( ::FontDialog1:Font )
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton4OnClick( oSender ) CLASS TForm1

   ::FontDialog1:Font:Assign( ::TStringGrid1:HeaderFont )
   ::FontDialog1:Caption := "Fuente cabecera"

   if ::FontDialog1:Execute()
      ::TStringGrid1:HeaderFont:Assign( ::FontDialog1:Font )
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton5OnClick( oSender ) CLASS TForm1

   ::FontDialog1:Font:Assign( ::TStringGrid1:FooterFont )
   ::FontDialog1:Caption := "Fuente pi"

   if ::FontDialog1:Execute()
      ::TStringGrid1:FooterFont:Assign( ::FontDialog1:Font )
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton6OnClick( oSender ) CLASS TForm1

   ::ColorDialog1:Caption := "Celda normal"
   ::ColorDialog1:Color := ::TStringGrid1:NormalColor

   if ::ColorDialog1:Execute()
      ::TStringGrid1:NormalColor := ::ColorDialog1:Color
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton7OnClick( oSender ) CLASS TForm1

   ::ColorDialog1:Caption := "Celda sel. y foco"
   ::ColorDialog1:Color := ::TStringGrid1:SelectedFocusColor

   if ::ColorDialog1:Execute()
      ::TStringGrid1:SelectedFocusColor := ::ColorDialog1:Color
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton8OnClick( oSender ) CLASS TForm1

   ::ColorDialog1:Caption := "Celda sel. y sin foco"
   ::ColorDialog1:Color := ::TStringGrid1:SelectedUnfocusColor

   if ::ColorDialog1:Execute()
      ::TStringGrid1:SelectedUnfocusColor := ::ColorDialog1:Color
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD ComboBox1OnChange( oSender ) CLASS TForm1

   ::TStringGrid1:FocusStyle := oSender:ItemIndex - 1

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton11OnClick( oSender ) CLASS TForm1

   ::TStringGrid1:Col--
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton12OnClick( oSender ) CLASS TForm1

   ::TStringGrid1:Col++
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton9OnClick( oSender ) CLASS TForm1

   ::TStringGrid1:Row--
   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton10OnClick( oSender ) CLASS TForm1

   ::TStringGrid1:Row++
   ::TStringGrid1:SetFocus()
   
return

/*
 * Evento OnChange.
 */
METHOD CheckBox6OnChange( oSender ) CLASS TForm1

   if ::CheckBox6:Checked
      ::TStringGrid1:OnSearch := { | oSender, cBuffer | ;
                                   If( Val( cBuffer ) < Len( ::TStringGrid1:Items ), ;
                                   ::TStringGrid1:Row := Val( cBuffer ), ;
                                   ::TStringGrid1:Row := Len( ::TStringGrid1:Items ) ) }
   else
      ::TStringGrid1:OnSearch := Nil
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnChange.
 */
METHOD CheckBox10OnChange( oSender ) CLASS TForm1

   if ::CheckBox10:Checked
      ::TStringGrid1:AllowEdit := .T.
   else
      ::TStringGrid1:AllowEdit := .F.
   endif

   ::TStringGrid1:SetFocus()

return

/*
 * Evento OnSearch.
 */
METHOD TStringGrid1OnSearch( oSender, cBuffer ) CLASS TForm1

   

return

/*
 * Evento OnClick.
 */
METHOD TStringGrid1OnClick( oSender ) CLASS TForm1

IF  ::TStringGrid1:GetData(1) = "->"
  ::TStringGrid1:Items[::TStringGrid1:RowPos,1] := "  "
ELSE
  ::TStringGrid1:Items[::TStringGrid1:RowPos,1] := "->"
ENDIF
* Truco para borrar el buffer de OnSearch, al cambiar el foco
   ::Label6:Setfocus()
   ::TStringGrid1:SetFocus()
   ::TStringGrid1:Refresh()
   

return